unit U_YarnOutList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData, cxDataStorage,
  cxEdit, DB, cxDBData, cxGridCustomTableView, cxGridTableView,
  cxGridBandedTableView, cxGridDBBandedTableView, cxGridLevel, cxClasses,
  cxControls, cxGridCustomView, cxGridDBTableView, cxGrid, StdCtrls, ComCtrls,
  ExtCtrls, ToolWin, cxGridCustomPopupMenu, cxGridPopupMenu, ADODB, DBClient,
  cxDropDownEdit, cxCheckBox, RM_Common, RM_Class, RM_e_Xls, RM_Dataset,
  RM_System, RM_GridReport, Menus, cxCalendar, cxButtonEdit, cxTextEdit, cxPC,
  cxLookAndFeels, cxLookAndFeelPainters, cxNavigator, dxDateRanges,
  dxBarBuiltInMenu, U_BaseList, cxContainer, dxScrollbarAnnotations, cxMaskEdit,
  FrameDateSel, dxSkinsCore, dxSkinsDefaultPainters, cxProgressBar,
  dxSkinOffice2013White, dxSkinSharpPlus, dxSkinWXI;

type
  TfrmYarnOutList = class(TfrmBaseList)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBFind: TToolButton;
    TBExport: TToolButton;
    TBClose: TToolButton;
    Panel1: TPanel;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    DataSource1: TDataSource;
    cxGridPopupMenu1: TcxGridPopupMenu;
    CDS_Main: TClientDataSet;
    TBDel: TToolButton;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    TBAdd: TToolButton;
    TBEdit: TToolButton;
    cxGrid1: TcxGrid;
    Tv1: TcxGridDBTableView;
    Tv1BYIOID: TcxGridDBColumn;
    Tv1IOTime: TcxGridDBColumn;
    Tv1IOType: TcxGridDBColumn;
    v1Column15: TcxGridDBColumn;
    Tv1FromCoName: TcxGridDBColumn;
    Tv1Y_Name: TcxGridDBColumn;
    Tv1Qty: TcxGridDBColumn;
    Tv1QtyUnit: TcxGridDBColumn;
    Tv1Note: TcxGridDBColumn;
    cxGrid1Level1: TcxGridLevel;
    Label3: TLabel;
    Label5: TLabel;
    Label8: TLabel;
    Label12: TLabel;
    Y_Name: TcxTextEdit;
    BYIOID: TcxTextEdit;
    Y_spec: TcxTextEdit;
    v1Column1: TcxGridDBColumn;
    v1Column10: TcxGridDBColumn;
    v1Column17: TcxGridDBColumn;
    Tv1BatchNo: TcxGridDBColumn;
    ToolButton1: TToolButton;
    Tv1ToCoName: TcxGridDBColumn;
    Tv1Y_Composition: TcxGridDBColumn;
    Tv1Y_Color: TcxGridDBColumn;
    Tv1Piece: TcxGridDBColumn;
    Tv1Y_Code: TcxGridDBColumn;
    ToolButton2: TToolButton;
    Tv1Column9: TcxGridDBColumn;
    frmFrameDateSel1: TfrmFrameDateSel;
    IOType: TcxComboBox;
    Label1: TLabel;
    Y_Code: TcxTextEdit;
    Tv1FF: TcxGridDBColumn;
    Label2: TLabel;
    WBCID: TcxTextEdit;
    Tv1StkID: TcxGridDBColumn;
    Label4: TLabel;
    StkID: TcxTextEdit;
    Label6: TLabel;
    Y_ColorNo: TcxTextEdit;
    Tv1ToOrdNo: TcxGridDBColumn;
    Tv1ToConNo: TcxGridDBColumn;
    Tv1SXCBH: TcxGridDBColumn;
    Tv1SXCPM: TcxGridDBColumn;
    Tv1Filler: TcxGridDBColumn;
    Tv1Filltime: TcxGridDBColumn;
    Tv1Editer: TcxGridDBColumn;
    Tv1Edittime: TcxGridDBColumn;
    Tv1FromPurNo: TcxGridDBColumn;
    Tv1FromConNo: TcxGridDBColumn;
    Tv1Denier: TcxGridDBColumn;
    Tv1ZS: TcxGridDBColumn;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure ConNoMChange(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBExportClick(Sender: TObject);
    procedure TBFindClick(Sender: TObject);
    procedure SPNameChange(Sender: TObject);
    procedure BYIOIDChange(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure TBAddClick(Sender: TObject);
    procedure TBEditClick(Sender: TObject);
    procedure Y_specChange(Sender: TObject);
    procedure cxTabControl1Change(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure BYIOIDPropertiesChange(Sender: TObject);
  private
    canshu1, FStkName, canshu3: string;
    procedure InitGrid();
    { Private declarations }
  public

    { Public declarations }
  end;

implementation

uses
  U_DataLink, U_RTFun, U_YarnOutEdit, U_LabelPrint;

{$R *.dfm}

procedure TfrmYarnOutList.FormDestroy(Sender: TObject);
begin
  inherited;  //frmPBOutList:=nil;
end;

procedure TfrmYarnOutList.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  inherited;
  Action := caFree;
end;

procedure TfrmYarnOutList.FormCreate(Sender: TObject);
begin
  inherited;
  canshu1 := Trim(self.fParameters1);
  FStkName := Trim(self.fParameters2);
  canshu3 := Trim(self.fParameters3);
  frmFrameDateSel1.EndDate.Date := SGetServerDate(ADOQueryTemp);
  frmFrameDateSel1.BegDate.Date := frmFrameDateSel1.EndDate.Date - 90;
end;

procedure TfrmYarnOutList.InitGrid();
begin
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered := False;
      Close;
      sql.Clear;
      sql.Add(' select A.* ');
      sql.Add(' from BS_Yarn_IO A');
      sql.add(' where A.IOTime>=''' + Trim(FormatDateTime('yyyy-MM-dd', frmFrameDateSel1.BegDate.Date)) + '''');
      sql.Add(' and A.IOTime<''' + Trim(FormatDateTime('yyyy-MM-dd', frmFrameDateSel1.enddate.Date + 1)) + '''');
      sql.Add(' and isnull(stkName,'''')=''' + Trim(FstkName) + '''');
      SQL.Add(' and ioFlag=''出库''  ');
//      if cxTabControl1.TabIndex = 0 then
//      begin
//        Sql.Add(' and ZFFlag=0 ');
//      end
//      else if cxTabControl1.TabIndex = 1 then
//      begin
//        Sql.Add(' and ZFFlag=1 ');
//      end;
//      ShowMessage (sql.TEXT)  ;
      Open;
    end;
    SCreateCDS(ADOQueryMain, CDS_Main);
    SInitCDSData(ADOQueryMain, CDS_Main);
  finally
    ADOQueryMain.EnableControls;
  end;
end;

procedure TfrmYarnOutList.TBRafreshClick(Sender: TObject);
begin
  ToolBar1.SetFocus;
  InitGrid();
end;

procedure TfrmYarnOutList.ToolButton1Click(Sender: TObject);
begin
  WriteCxGrid(trim(Self.Caption), Tv1, '纱线仓库');

end;

procedure TfrmYarnOutList.ToolButton2Click(Sender: TObject);
var
  MBYIOID: string;
begin
  if CDS_Main.IsEmpty then
    Exit;
  if CDS_Main.Locate('SSel', True, []) = False then
  begin
    Application.MessageBox('没有选择数据!', '提示', 0);
    Exit;
  end;

  MBYIOID := '';
  CDS_Main.DisableControls;
  with CDS_Main do
  begin
    First;
    while CDS_Main.Locate('SSel', True, []) do
    begin

      MBYIOID := MBYIOID + ',' + (Trim(CDS_Main.fieldbyname('BYIOID').AsString));

      Edit;
      FieldByName('SSel').Value := False;
      Post;
    end;
  end;
  CDS_Main.EnableControls;

  try
    frmLabelPrint := TfrmLabelPrint.Create(Application);
    with frmLabelPrint do
    begin
      FLMType := 'BSYarnOutPrt1';
      FFiltration1 := MBYIOID;
      if ShowModal = 1 then
      begin
//        Self.InitGrid();
      end;
    end;
  finally
    frmLabelPrint.Free;
  end;
end;

procedure TfrmYarnOutList.BYIOIDPropertiesChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmYarnOutList.ConNoMChange(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
  end;
end;

procedure TfrmYarnOutList.TBCloseClick(Sender: TObject);
begin

  Close;
end;

procedure TfrmYarnOutList.FormShow(Sender: TObject);
var
  mSql: string;
begin
  inherited;
  mSql := 'select distinct name=A.IOType from BS_Yarn_IO A where IOFlag=''出库'' and isnull(STKNAME,'''')=''' + Trim(FSTKNAME) + ''' ';
  SInitTcxComBoxBySql(ADOQueryTemp, IOType, false, mSql);
  ReadCxGrid(trim(Self.Caption), Tv1, '纱线仓库');
  InitGrid();
end;

procedure TfrmYarnOutList.TBExportClick(Sender: TObject);
begin
  if ADOQueryMain.IsEmpty then
    exit;
  TcxGridToExcel(FstkName + '出库列表', cxGrid1);
end;

procedure TfrmYarnOutList.TBFindClick(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
    SCreateCDS(ADOQueryMain, CDS_Main);
    SInitCDSData(ADOQueryMain, CDS_Main);
  end;
end;

procedure TfrmYarnOutList.SPNameChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmYarnOutList.BYIOIDChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmYarnOutList.N1Click(Sender: TObject);
begin
  SelOKNo(CDS_Main, True);
end;

procedure TfrmYarnOutList.N2Click(Sender: TObject);
begin
  SelOKNo(CDS_Main, False);
end;

procedure TfrmYarnOutList.TBDelClick(Sender: TObject);
var
  MBYIOID: string;
begin
  if CDS_Main.IsEmpty then
    Exit;

  if Application.MessageBox('确定要删除数据吗？', '提示', 32 + 4) <> IDYES then
    Exit;

  if CDS_Main.IsEmpty then
    Exit;
  if CDS_Main.Locate('SSel', True, []) = False then
  begin
    Application.MessageBox('没有选择数据!', '提示', 0);
    Exit;
  end;

  MBYIOID := '';
  CDS_Main.DisableControls;
  with CDS_Main do
  begin
    First;
    while CDS_Main.Locate('SSel', True, []) do
    begin

      MBYIOID := MBYIOID + ',' + Trim(CDS_Main.fieldbyname('BYIOID').AsString);
      CDS_Main.Delete;
    end;
  end;
  CDS_Main.EnableControls;
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('exec P_Fin_Flow_Judge ');
    Sql.Add(' @FFIDS=' + quotedstr(MBYIOID));
    Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
    Sql.Add(',@DName=' + quotedstr(Trim(DName)));
    Open;
  end;
  if ADOQueryTemp.FieldByName('intReturn').AsInteger = -1 then
  begin
    Application.MessageBox(PChar(ADOQueryTemp.fieldbyname('ShowMsg').AsString), '提示', 0);
    exit;
  end;
  try
    ADOQueryCmd.Connection.BeginTrans;
    with ADOQueryCmd do
    begin
      Close;
      Sql.Clear;
      sql.Add('insert into Finance_Need_Up(UType,UDataId,UOperation,UOperator,UModule,UDetails)       ');
      sql.Add('values(''纱线出库''    ');
      sql.Add(',' + quotedstr(MBYIOID));
      sql.Add(',''删除''   ');
      sql.Add(',' + quotedstr(DName));
      sql.Add(',' + quotedstr(trim(self.Caption)));
      sql.Add(',' + quotedstr(MBYIOID));
      sql.Add(')  ');

      Sql.Add('exec P_BS_Yarn_Out_Del ');
      Sql.Add(' @BYIOIDS=' + quotedstr(MBYIOID));
      Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
      Sql.Add(',@DName=' + quotedstr(Trim(DName)));
      Open;
    end;
    if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
      raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));
    ADOQueryCmd.Connection.CommitTrans;
    InitGrid();
  except
    ADOQueryCmd.Connection.RollbackTrans;
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
  end;

end;

procedure TfrmYarnOutList.TBAddClick(Sender: TObject);
begin
  try
    frmYarnOutEdit := TfrmYarnOutEdit.Create(Application);
    with frmYarnOutEdit do
    begin
      FBCId := '';
      FstkName := Self.FstkName;
      if ShowModal = 1 then
      begin
        Self.InitGrid();
      end;
    end;
  finally
    frmYarnOutEdit.Free;
  end;
end;

procedure TfrmYarnOutList.TBEditClick(Sender: TObject);
begin
  if CDS_Main.IsEmpty then
    Exit;
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('exec P_Fin_Flow_Judge ');
    Sql.Add(' @FFIDS=' + quotedstr(Trim(CDS_Main.fieldbyname('BYIOID').AsString)));
    Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
    Sql.Add(',@DName=' + quotedstr(Trim(DName)));
    Open;
  end;
  if ADOQueryTemp.FieldByName('intReturn').AsInteger = -1 then
  begin
    Application.MessageBox(PChar(ADOQueryTemp.fieldbyname('ShowMsg').AsString), '提示', 0);
    exit;
  end;
  with ADOQueryTemp do
  begin
    Close;
    Sql.Clear;
    Sql.Add('exec P_BS_Yarn_Out_Edit ');
    Sql.Add(' @BYIOIDS=' + quotedstr(Trim(CDS_Main.fieldbyname('BYIOID').AsString)));
    Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
    Sql.Add(',@DName=' + quotedstr(Trim(DName)));
//    ShowMessage(sql.Text);
    Open;
  end;
  if ADOQueryTemp.FieldByName('intReturn').AsInteger = -1 then
  begin
    Application.MessageBox(PChar(ADOQueryTemp.fieldbyname('ShowMsg').AsString), '提示', 0);
    exit;
  end;
  try
    frmYarnOutEdit := TfrmYarnOutEdit.Create(Application);
    with frmYarnOutEdit do
    begin
      FBCId := Trim(CDS_Main.fieldbyname('BYIOID').AsString);
      TBDel.Visible := False;
      TBAdd.Visible := False;
      FstkName := Self.FstkName;
      if ShowModal = 1 then
      begin
        Self.InitGrid();
      end;
    end;
  finally
    frmYarnOutEdit.Free;
  end;

end;

procedure TfrmYarnOutList.Y_specChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmYarnOutList.cxTabControl1Change(Sender: TObject);
begin
  InitGrid();
end;

end.

